<xsl:stylesheet version="1.0" 
  xmlns:xsl ="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" indent="yes" encoding="UTF-8"/>

<!--============================================================-->
<!-- despan: delete empty <span> tags and do some other cleanup -->
<!--============================================================-->

<!-- if this is a ThML document, output DTD -->  
<xsl:template match="ThML">
    <xsl:text disable-output-escaping="yes">&lt;!DOCTYPE ThML PUBLIC 
    "-//CCEL/DTD Theological Markup Language//EN"
    "http://www.ccel.org/dtd/ThML10.dtd"&gt;
&lt;?xml-stylesheet type="text/xsl"
    href="http://www.ccel.org/ss/thml.html.xsl" ?&gt;
    
</xsl:text>
    
    <ThML>
      <xsl:apply-templates/>
    </ThML>
</xsl:template>
    

<!-- delete span tags without attributes -->
<xsl:template match="span[count(@*)=0 or (count(@*)=1 and @id != '')]">
  <xsl:apply-templates/>
</xsl:template>

<!-- convert class="Italic", class="Bold", etc. to tags -->
<xsl:template match="span[@class='Italic']">
  <i><xsl:apply-templates/></i>
</xsl:template>

<xsl:template match="span[@class='Bold']">
  <b><xsl:apply-templates/></b>
</xsl:template>

<xsl:template match="span[@class='Sub']">
  <sub><xsl:apply-templates/></sub>
</xsl:template>

<xsl:template match="span[@class='Super']">
  <sup><xsl:apply-templates/></sup>
</xsl:template>

<!-- pass through everything else unchanged -->
<xsl:template match="*">
  <xsl:element name="{local-name()}">
    <xsl:copy-of select="@*"/>
    <xsl:apply-templates/>
  </xsl:element>
</xsl:template>

</xsl:stylesheet>
